require "import"
import "android.content.Intent"
import "android.content.pm.ApplicationInfo"
import "android.content.Context"
import "android.content.pm.PackageManager"
import "android.widget.ArrayAdapter"
import "android.widget.GridView"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "android.widget.Toast"
import "android.widget.EditText"
import "android.os.Vibrator"
import "android.view.Gravity"
import "com.androlua.*"

local context = activity or service
local packageManager = context.getPackageManager()
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
local selectedApp1, selectedApp2 = nil, nil
local function openAppsInSplitScreen()
if selectedApp1 then
local intent1 = packageManager.getLaunchIntentForPackage(selectedApp1.packageName)
if intent1 then
intent1.addFlags(Intent.FLAG_ACTIVITY_LAUNCH_ADJACENT)
context.startActivity(intent1)
else
Toast.makeText(context, "Intensi peluncuran tidak ditemukan untuk aplikasi yang dipilih", Toast.LENGTH_SHORT).show()
end
else
Toast.makeText(context, "Anda harus memilih aplikasi terlebih dahulu", Toast.LENGTH_SHORT).show()
end
end
local installedApplications = packageManager.getInstalledApplications(PackageManager.GET_META_DATA)
local appNames = {}
local installedAppInfos = {}
for i = 1, installedApplications.size() do
local appInfo = installedApplications.get(i - 1)
if (appInfo.flags & ApplicationInfo.FLAG_SYSTEM) == 0 then
local appName = appInfo.loadLabel(packageManager)
local packageName = appInfo.packageName
local intent = packageManager.getLaunchIntentForPackage(packageName)
if intent then
installedAppInfos[appName] = appInfo
appNames[#appNames + 1] = appName
end
end
end
table.sort(appNames)
local function filterApps(query)
local filteredApps = {}
for _, appName in ipairs(appNames) do
if string.match(string.lower(appName), string.lower(query)) then
table.insert(filteredApps, appName)
end
end
return filteredApps
end
local gridView = GridView(context)
gridView.setNumColumns(1)
gridView.setLayoutParams(LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT))
local adapter = ArrayAdapter(context, android.R.layout.simple_list_item_1, appNames)
gridView.setAdapter(adapter)
local searchEditText = EditText(context)
searchEditText.setLayoutParams(LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT))
--cari
local currentApps = appNames
searchEditText.addTextChangedListener({
onTextChanged = function(s, start, before, count)
local searchText = tostring(s)
if #searchText > 0 then
local filteredApps = filterApps(searchText)
currentApps = filteredApps
gridView.setAdapter(ArrayAdapter(context, android.R.layout.simple_list_item_1, filteredApps))
else
currentApps = appNames
gridView.setAdapter(ArrayAdapter(context, android.R.layout.simple_list_item_1, appNames))
end
end
})
local linearLayout = LinearLayout(context)
linearLayout.setOrientation(LinearLayout.VERTICAL)
linearLayout.setLayoutParams(LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT))
local titleTextView = TextView(context)
titleTextView.setTextSize(20)
titleTextView.setGravity(Gravity.CENTER)
titleTextView.setPadding(16, 16, 16, 16)
linearLayout.addView(titleTextView)
linearLayout.addView(searchEditText)
linearLayout.addView(gridView)
local dlg = LuaDialog(context)
require("tombol")(titleTextView, dlg, searchEditText)
dlg.setView(linearLayout)
gridView.setOnItemClickListener{
onItemClick = function(parent, view, position, id)
local appName = currentApps[position + 1]
vibrator.vibrate(100)
Toast.makeText(context, " " .. appName, Toast.LENGTH_SHORT).show()

if not selectedApp1 then
selectedApp1 = installedAppInfos[appName]
openAppsInSplitScreen()
dlg.dismiss()
end
end
}

dlg.show()